/*
 * Copyright 2004-2005 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 * XSEC
 *
 * XKMSResponseMechanismImpl := Implementation of XKMSResponseMechanism
 *
 * $Id: XKMSResponseMechanismImpl.hpp 351217 2005-02-03 14:30:30Z milan $
 *
 */

#ifndef XKMSRESPONSEMECHANISMIMPL_INCLUDE
#define XKMSRESPONSEMECHANISMIMPL_INCLUDE

// XSEC Includes

#include <xsec/framework/XSECDefs.hpp>
#include <xsec/xkms/XKMSResponseMechanism.hpp>

class XSECEnv;

class XKMSResponseMechanismImpl : public XKMSResponseMechanism {

public:

	XKMSResponseMechanismImpl(const XSECEnv * env);
	XKMSResponseMechanismImpl(		
		const XSECEnv * env, 
		XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * node
	);

	virtual ~XKMSResponseMechanismImpl();

	// load
	void load(void);

	XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * 
		createBlankResponseMechanism(
		const XMLCh * item);

	/* Getter Interface Methods */

	virtual XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * getElement(void) const {
		return mp_responseMechanismElement;
	}

	virtual const XMLCh * getResponseMechanismString(void) const;

	/* Setter interface methods */

	virtual void setResponseMechanismString(const XMLCh * str);

	//@}


private:

	const XSECEnv			* mp_env;
	XERCES_CPP_NAMESPACE_QUALIFIER DOMElement 
							* mp_responseMechanismElement;
	XERCES_CPP_NAMESPACE_QUALIFIER DOMNode
							* mp_responseMechanismTextNode;

	// Unimplemented
	XKMSResponseMechanismImpl(const XKMSResponseMechanismImpl &);
	XKMSResponseMechanismImpl & operator = (const XKMSResponseMechanismImpl &);

};

#endif /* XKMSRESPONSEMECHANISMIMPL_INCLUDE */
